module Rewire
  class Emitter
    def self.new(pipe, next_emitter = nil)
      if next_emitter
        TrunkEmitter.new(pipe, next_emitter)
      else
        LeafEmitter.new(pipe)
      end
    end
  end

  class LeafEmitter
    def initialize(pipe)
      @pipe = pipe
    end

    def |(pipe)
      Emitter.new(@pipe, Emitter.new(pipe))
    end

    def <<(pack)
      @pipe << pack
    end
  end

  class TrunkEmitter
    def initialize(pipe, next_emitter)
      @pipe, @next_emitter = pipe, next_emitter
    end

    def |(pipe)
      Emitter.new(@pipe, @next_emitter | pipe)
    end

    def <<(pack)
      @pipe.process(@next_emitter, pack)
    end
  end
end
